<?php

if(!function_exists('cg_check_headers_sent')){
    function cg_check_headers_sent(){
        if(headers_sent()){
            ?>
            <script data-cg-processing="true">
                cgJsClass.gallery.function.message.show('Some other plugin have already sent headers. Login not possible.');
            </script>
            <?php
            return true;
        }else{
            return false;
        }
    }
}

if(!function_exists('cg_check_if_database_tables_ok')){
    function cg_check_if_database_tables_ok(){

        global $wpdb;
        $tablename = $wpdb->prefix . "contest_gal1ery";
        $tablenameOptions = $wpdb->prefix . "contest_gal1ery_options";
        $tablename_pro_options = $wpdb->prefix . "contest_gal1ery_pro_options";

        if(
            ($wpdb->get_var("SHOW TABLES LIKE '$tablename'") != $tablename) ||
            ($wpdb->get_var("SHOW TABLES LIKE '$tablenameOptions'") != $tablenameOptions) ||
            ($wpdb->get_var("SHOW TABLES LIKE '$tablename_pro_options'") != $tablename_pro_options)
        )
        {
            if (is_multisite()) {
                $i=get_current_blog_id();
                if($i==1){
                    $i="";
                    $lastError = contest_gal1ery_create_table($i,true);
                }else {
                    $lastError = contest_gal1ery_create_table($i."_",true);
                }
            }else{
                $i='';
                $lastError = contest_gal1ery_create_table($i,true);
            }
            if(!empty($lastError)){
                // message normal and message PRO here!
                $plugin_dir_path = plugin_dir_path(__FILE__);
                echo "<b>There were errors when trying to create database tables.<br>";
                echo "If the errors are not understandable and the reason unclear<br>";
                echo "please contact following email, copy paste and send the errors information above to:</b><br>";
                if(cg_get_version()=='contest-gallery-pro'){
                    echo '<a href="mailto:support-pro@contest-gallery.com">support-pro@contest-gallery.com</a>';
                }else{
                    echo '<a href="mailto:support@contest-gallery.com">support@contest-gallery.com</a>';
                }
                echo "<br><br><br><br><br><br><br><br><br>";
                die;
            }
        }
    }
}

if(!function_exists('cg_check_if_upload_folder_permissions_ok')){
    function cg_check_if_upload_folder_permissions_ok(){

        $wp_upload_dir = wp_upload_dir();
        $isWritable = true;
        if(!is_writable($wp_upload_dir['basedir'])){
            $isWritable = false;
        }
        if($isWritable){// test file creation
            $cgTestFileName = 'contest-gal1ery-test-file.txt';
            try {
                file_put_contents($wp_upload_dir['basedir'].'/'.$cgTestFileName,'test');
            }catch (Exception $e){
                // no exception printing so far required
            }
            if(file_exists($wp_upload_dir['basedir'].'/'.$cgTestFileName)){
                unlink($wp_upload_dir['basedir'].'/'.$cgTestFileName);
            }else{
                $isWritable = false;
            }
        }
        if(!$isWritable){
            echo "<b>No files and folders can be created created in your main upload folder:</b><br>";
            echo $wp_upload_dir['basedir'];
            echo "<br><b>Recommended WordPress permissions for a wp-content/uploads folder are: 755</b><br>";
            die;
        }
    }
}

if(!function_exists('cg_echo_last_sql_error')){
    function cg_echo_last_sql_error($isShowError,& $lastError = ''){
        if($isShowError){
            global $wpdb;
            $wpdb->show_errors(true);
            $wpdb->suppress_errors(false);//<<< set for sure, but somehow always surpressed by WordPress
            if($wpdb->last_error!=$lastError){
                $lastError = $wpdb->last_error;
                echo "<div>";
                echo "<br><b>Query:</b><br> ";
                echo $wpdb->last_query;
                echo "<br><b>Error:</b><br> ";
                echo $lastError;// error somehow always surpressed by WordPress
                echo "<br><br>";
                echo "</div>";
                return $lastError;
            };
        }
        return $lastError;
    }
}

?>